VTS stands for __Vendor Test Suite__, and is the standard test suite of Android system.

Developer testing refers to using tests written by developers with component
domain expertise and is usually used to test a feature or a bug fix that was
recently developed or is under development.

VTS structural testing framework is developed to encourage such TDD
(Test-Driven Development) culture in the Android system development.
Historically, TDD was not widely used in certain consumer electronics industry segments
as compared with some other industry (e.g., for mission-critical or high-availability systems).
As the Android system is being used widely (i.e., requiring frequent security
patching and fast feature launch velocity), we think that it is a right cultural shift for this time.

Currently, all VTS tests are designed for userdebug or eng build devices only.

__Table of Contents__

1.  Host-Driven Tests
    * [Codelab for Shell-Based Simple Test](codelab_host_driven_test.md)
    * [Codelab for VTS Specification File](codelab_vts_spec.md)

2.  Native Code Coverage
    * [Codelab for Native Code Coverage Measurement](codelab_native_code_coverage.md)
    * [Native Coverage Information and FAQ](native_coverage_faq.md)

3.  Enable Profiling for VTS Hidl HAL Tests
    * [Codelab for Profiling VTS Hidl HAL Tests](codelab_enable_profiling.md)

4. FAQs
    * [How to directly run a VTS test without using VTS-TradeFed](run_vts_directly.md)